#!/usr/local/bin/perl
##############################################################################
# Copyright: Binny V Abraham 2004-2005                                       #
# If you want to use this script, Leave this message here                    #
##############################################################################
# Contact me At binnyva@hotmail.com                                          #
# Or At http://www.geocities.com/binnyva                                     #
##############################################################################
# Name Of Script : CGI GuestBook                                             #
# Version        : 1.00.A                                                    #
# This script is to collect visitor information form the public and store    #
# in a file for your viewing.                                                #
# This script also includes a self created acknowledgment page.              #
# It is essential to have the form to which this file should be linked.      #
# Without it, this script will not function.                                 #
# 'guestbook.html' is the file that takes in the info and passes it to the   #
# script'                                                                    #
# This script is different from the 'Guest Book' perl script that is         #
# available from my site in the following ways                               #
# - This script uses the CGI module.                                         #
# - Will function even if there is no 'guest.html' file by creating one.     #
# - Can write to text files in another way - without HTML tags.              #
# - Don't have Ratings and Strength field.                                   #
# NOTE : Use this script only if you have the CGI Module.                    #
#                                                                            #
# Get more Perl scripts from http://www.geocities.com/binnyva/code/perl      #
##############################################################################
# use strict;
use CGI qw/:standard/;
$CGI::POST_MAX = 1024 * 100;# Max 100K posts
$CGI::DISABLE_UPLOADS = 1;  # No uploads

# Set Variables
my $guestfile = "guest.html"; # Guest Book
my $separator = "-";          # Date sepeator (9'-'10..)

# Get input
my $cgi = new CGI;
my $name    = $cgi->param('name');
my $email   = $cgi->param('email');
my $location= $cgi->param('loc');
my $comments= $cgi->param('comments');

# Get the date of entry into the guestbook
my ($mday, $mon, $year) = (localtime(time))[3,4,5]; #We need only the day, the month and year.
$mon += 1;
$year += 1900;
my $date = "$mday$separator$mon$separator$year"; #Date formating in D-M-YYYY

#Give default values if the variables are empty
$name    = "-" unless $name;
$email   = "-" unless $email;
$location= "-" unless $location;
$comments= "-" unless $comments;

### Writing To File
my @LINES = "";
my $SIZE = 0;

# Open Guest Book File
if (open (FILE, "$guestfile")) {
    @LINES=<FILE>;
    close(FILE);
    $SIZE=@LINES;
} else {
    #No file called $guestfile exist - Make A new one.
    open (OUT, ">$guestfile") or die "Internal Error. Can't open $guestfile for writing: $!.\n";
    print OUT <<HTML_FILE;
<HTML><HEAD>
<TITLE>Guest Book</TITLE>
<style>
<!--
td.caps { text-transform:capitalize; }
//-->
</style>
</HEAD>
<body>
<H1 align="center">Guest Book</H1>
<center><table border="1" width="95%">
<tr><td align="center"><b>Name</b></td><td align="center"><b>E-Mail</b></td><td align="center"><b>Location</b></td><td align="center"><b>Date</b></td></tr>
<tr><td align="center" colspan=4><b>Comments</b></td></tr>
<!--top-->


</table></center><br>
</body></HTML>
HTML_FILE
    close OUT;
    # After the file is made, open it an read the contents
    open (FILE, "$guestfile") or die "Internal Error. Can't open $guestfile: $!\n";
    @LINES=<FILE>;
    close(FILE);
    $SIZE=@LINES;
}

# Open Guest Book File and inputing the content
my $found = 0;
open (FILE, ">$guestfile") || die "Internal Error. Can't open $guestfile: $!\n";
for (my $i = 0; $i <= $SIZE; $i++) {
    $_ = $LINES[$i];
    if (/<!--top-->/) {
        #Put the contents at the TOP - so the the latest entry will be at the top of the file
        $found++;
        print FILE "<!--top-->\n";
        print FILE "<tr><td class=caps>$name</td><td><a href='mailto:$email'>$email</a></td><td class=caps>$location</td><td noWrap>$date</td></tr>\n";
        print FILE "<tr><td colspan=4 class=comments>$comments</td></tr>\n";
    }
    else {
        print FILE $_;
    }
}
close (FILE);

if (!$found) {
    #Failsafe. - If the guestfile is not a HTML file, there will not be any <!--top--> - So just append it.
    open (APPENDER, ">>$guestfile") || die "Internal Error. Can't open $guestfile: $!\n";
    print APPENDER "$name\($email\) from $location left a comment on $date. Comments : $comments\n";
    close (APPENDER);
}

### Output

#Give output
print <<START;

Content-Type: text/html\n\n
<html><head>
<title>Guest book Result</title>
<body>
<h1 align="center">Guest book Results</h1>

Dear $name,<BR>Thank You for filling out our Guest Book. 
I appreciate this effort in your part.<br><br>
<table>
<tr><td width=100>Name</td><td>$name</td></tr>
<tr><td>E Mail</td><td>
<a href="mailto:$email">$email</a></td></tr>
<tr><td>Location</td><td>$location</td></tr>
<tr><td>Comments</td><td>$comments</td></tr>
</table>

<br><br>
<a href=$guestfile>View Guest Book</a><br>
</body>
</html>
START
